#!/usr/bin/perl
# LIBARY FOR WEBMIN-MODULE "GEHRIGAL THEMECONFIGURATOR"
#
#+++++++++++++++++++++++++++++++++++++++++++++++++++++
# Autor: Alexander Gehrig
# EMail: webmin@gehrigal.de
# URL: http://www.gehrigal.net ( http://www.gehrigal.de )
#+++++++++++++++++++++++++++++++++++++++++++++++++++++

require '../web-lib.pl';
&init_config();
# require '../theme_gehrigal/theme-lib.pl';


#**SUB************************************************
#
# name: module_name
# info: Output the name of the module
#

sub module_name
{
    my $file = "$_[0]".'module.version';
    
    open(VERSION, "< $file");
    @version = <VERSION>;
    close(VERSION);
    
    chomp @version;
    
    my $line = "";
    my $name = "";
    my $value = "";
    my %hash = ();
    
    foreach $line (@version)
    {
    ($name, $value) = split '=' , $line, 2;
    $hash{$name} = $value;
    }
    
    $name_ = $hash{name};
    
    return $name_;
}

#**SUB************************************************
#
# name: module_version
# info: Output the version of the module
#

sub module_version
{
    my $file = "$_[0]".'module.version';
    
    open(VERSION, "< $file");
    @version = <VERSION>;
    close(VERSION);
    
    chomp @version;
    
    my $line = "";
    my $name = "";
    my $value = "";
    my %hash = ();
    
    foreach $line (@version)
    {
    ($name, $value) = split '=' , $line, 2;
    $hash{$name} = $value;
    }
    
    $version = $hash{version};
    
    return $version;
}

#**SUB************************************************
#
# name: file_reader
# info: Output the Content of a file
#

sub file_reader
{
my $file = $_[0];

open(FILE, "< $file");
my @content = <FILE>;
close(FILE);

my $line = "";

foreach $line (@content)
{
print "$line"; 

}

}


#**SUB************************************************
#
# name: file_writer
# info: Write the content of a ARRAY in a file
#

sub file_writer
{

my $file = $_[0];
my @array = $_[1];
open(FILE, "> $file");
close(FILE);
open(FILE, ">> $file");

my $line = '';

foreach $line (@array)
{
print FILE "$line\n";
}
close(FILE);

}


#**SUB************************************************
#
# name: skinbuilder_default
# info: Create the Skin-Directory and copy the default files to this Directory.
#	It changes the pathes additionally.
#
# Not tested yet!

sub skinbuilder_default
{

my $skinname = $_[0];

my $skinpath = "$config{path_for_skins}".'/webmin_skinbuilder';
#my $skinpath = '/temp/webmin_skinbuilder';
my $skininfo_file = "$skinname".'.skininfo';

if(!-d "$skinpath"){mkdir $skinpath;}
if(!-d "$skinpath/$skinname"){mkdir "$skinpath/$skinname";}else{print 'ERROR - The skin you will create already exist!';}

my $skininfo = &file_reader('skin_defaults/default.skininfo');
&file_writer("$skinpath/$skinname/$skininfo_file",$skininfo);

my $config_skin = &file_reader('skin_defaults/config.skin');
&file_writer("$skinpath/$skinname/config.skin",$config_skin);

my $config_css = &file_reader('skin_defaults/config.css');
&file_writer("$skinpath/$skinname/config.css",$config_css);

my $theme_config = &file_reader('skin_defaults/theme.config');
&file_writer("$skinpath/$skinname/theme.config",$theme_config);

my $theme_css = &file_reader('skin_defaults/theme.css');
&file_writer("$skinpath/$skinname/theme.css",$theme_css);

}



#**SUB******************************************************
# name: theme_version()
# info:  Output the version of Theme 'gehrigal'

sub theme_version
{
#my $theme_path = '../theme_gehrigal/theme.version';
my $theme_path = $_[0];

open(THEME ,"< $theme_path");
my @temp = <THEME>;
close (THEME);


chomp @temp;

my $zeile = "";
my $name = "";
my $wert = "";
my %hash = ();
foreach $zeile (@temp)
{
  ($name, $wert) = split "=", $zeile;
        $hash{$name} = $wert;
}
	
my $themever = $hash{themeversion};

return $themever;	
}

#**SUB******************************************************
# name: list_dir_content()
# info: Print's the content of a Dir 

sub list_dir_content
{

my $path = $_[0];

opendir(DIR, "$path");

my @dir = readdir DIR;

closedir(DIR);

my $line= '';

foreach $line (@dir)
{
print "$line <br>\n";
}


}


#**SUB******************************************************
# name: failure_gen()
# info: This creates a failure message
# parameter: Failure

sub failure_gen
{
my ($q, $cause) = @_;

print	$q->header("text/html"),
	$q->start_html("Failure"),
	$q->h1("Failure"),
	$q->p("$cause"),
	$q->end_html;

}



#**SUB******************************************************
# name: list_created_skins() & list_created_skins_wanted()
# info: list all skins, that was created by skinbuilder

sub list_created_skins
{
use File::Find;

my $dir = $_[0];
find(\&list_created_skins_wanted, $dir);

}

sub list_created_skins_wanted
{
if (-d $File::Find::name)
    {
	my $skininfo = "$dir"."/"."$File::Find::name"."/"."$File::Find::name".".skininfo";
	if ( -e $skininfo )
	{
	    print "$File::Find::name <br>";
	}
	# print "$File::Find::name / $skininfo<br>";
    }
 
}

#**SUB******************************************************
# name: sec_check_path()
# info: Check if path is a part of cpath (true = 1 / false = 0)

sub sec_check_path
{
    my $path = $_[0];
    my $cpath = $_[1];

    my $check = grep /$cpath/, `$config{cmd_find} $path`;

    if( $check == 0)
    {
	return 0;
    }
    else
    {
	return 1;
    }
    
    
}

#**SUB******************************************************
# name: rm_creturn()
# info: Remove all "13 0x0D" (carriage return) from a string

sub rm_creturn
{
my $string = $_[0];
$string =~ s/\r//g;
return $string;
}


return 1;